Go to the first, previous, next, last section, table of contents.

# 6 Settings and resources

In the VICE emulators, all the settings are stored in entities known as called resources. Each resource has a name and a value which may be either an integer or a string. Integer values are often used as boolean values with the usual convention of using zero for "false" and any other value for "true".

Resource values can be changed via the right-button menu (the settings menu), via command-line options or via the resource file.

The resource file is a human-readable file containing resource values: it is called ``vicerc'` and is stored in the directory ``.vice/'` in the user's home directory. It is possible to dump the current values of the resources into that file or load the values stored into that file as the current values, at any time. This is achieved with the "Save settings" and "Load settings" right menu items. A third menu item, "Restore Default Settings", can be used to reset all the values to the factory defaults.

A special resource, `SaveResourcesOnExit`, if set to a non zero value, causes the emulator to ask you if you want to save the current (changed) settings before exiting, and can be toggled with the "Save settings on exit" command from the right-button menu.

Notice that not all the resources can be changed from the menus; some of them can only be changed by manually modifying the resource file or by using command-line options.

## 6.1 Format of resource files

A resource file is made up of several sections; sections have the purpose of separating the resources of a certain emulator from the ones of the other emulators. A section starts with the name of an emulator in brackets (e.g., ``[C64]'`) and ends when another section starts or when the file ends.

Every line in a section has the following format:

    RESOURCE=VALUE

where `RESOURCE` is the name of a resource and `VALUE` is its assigned value. Resource names are case-sensitive and resource values are either strings or integers. Strings must start and end with a double quote character (`"`), while integers must be given in decimal notation.

Here is an example of a stripped-down ``.vice/vicerc'` file:

    [VIC20]
    HTMLBrowserCommand="netscape %s"
    SaveResourcesOnExit=0
    FileSystemDevice8=1
    FSDevice8ConvertP00=1
    FSDevice8Dir="/home/ettore/cbm/stuff/vic20p00"
    FSDevice8SaveP00=1
    FSDevice8HideCBMFiles=1
    [C64]
    HTMLBrowserCommand="netscape %s"
    SaveResourcesOnExit=1
    FileSystemDevice8=1
    FSDevice8ConvertP00=1
    FSDevice8Dir="/home/ettore/cbm/stuff/c64p00"
    FSDevice8SaveP00=1
    FSDevice8HideCBMFiles=1

Notice that, when resource values are saved with "Save settings", the emulator only modifies its own section, leaving the others unchanged.

## 6.2 Using command-line options to change resources

Resources can also be changed via command-line options.

Command-line options always override the defaults from `.vice/vicerc`, and their assignments last for the whole session. So, if you specify a certain command-line option that changes a certain resource from its default value and then use "Save Settings", the value specified with the command-line option will be saved back to the resource file.

Command-line options can begin with with a minus sign (``-'`) or with a plus sign (``+'`). Options beginning with a minus sign may require an additional parameter, while the ones beginning with the plus sign never require one.

Moreover, options beginning with a plus sign always have a counterpart with the same name, but with a minus sign; in that case, the option beginning with a minus sign is used to enable a certain feature, while the one beginning with a plus sign is used to disable the same feature (this is an X11 convention). For example, `-mitshm` enables support of MITSHM, while `+mitshm` disables it.

## 6.3 Performance settings

It is possible to control the emulation speed by using the "Maximum speed" menu item in the right-button menu. The default setting is `100`, which causes the emulation to never run faster than the real machine. A higher value allows the emulator to run faster, a lower one may force it to run slower. The setting "No limit" means to run as fast as possible, without limiting speed.

It is also possible to control the emulator's rate of frame update using the "Refresh rate" setting; the value ranges from "1/1" (update 1/1 of the frames of the real machine, that is 50 frames per second) to "1/10" (update 1 every 10 frames) and can be changed via the "Refresh Rate" submenu. The "Auto" setting means to dynamically adapt the refresh rate to the current speed of the host machine, making sure the maximum speed specified by the via "Maxium speed" is always reached if possible. In any case, the refresh rate will never be worse than 1/10 if this option is specified.

Note that you cannot simultaneously specify "Auto" as the refresh rate and "No limit" as the maximum speed..

Moreover, a special warp speed mode is provided and can be toggled with the "Enable Warp Mode" menu item. If this mode is enabled, it will cause the emulator to disable any speed limit, turn sound emulation off and use a 1/10 refresh rate, so that it will run at the maximum possible speed.

### 6.3.1 Performance resources

`Speed`
  Integer specifying the maximum relative speed, as a percentage. `0` stands for "no limit".
`RefreshRate`
  Integer specifying the refresh rate; a value of `n` specifies a refresh rate of 1/`n`. A value of `0` enables automatic frame skipping.
`WarpMode`
  Booolean specifying whether "warp mode" is turned on or not.

### 6.3.2 Performance command-line options

`-speed VALUE`
  Specifies the maximum speed as a percentage. `0` stands for "no limit". (Same as setting the `Speed` resource.)
`-refresh VALUE`
  Specifies refresh rate; a value of `n` specifies a refresh rate of 1/`n`. A value of `0` enables automatic frame skipping. (Same as setting the `RefreshRate` resource.)
`-warp`
`+warp`
  Enables/disables warp mode (`WarpMode=1`, `WarpMode=0`).

## 6.4 Video settings

The following right-button menu items control the video output. On emulators that include two video chips (like `x128`) all options but XSync exist twice, once for each chip. XSync is shared between the video chips.

- "Video Cache" enables a video cache that can speed up the emulation when little graphics activity is going on; it is especially useful when you run the emulator on a networked X terminal as it can reduce the network bandwidth required. However, this setting can actually make the emulator slower when there is little graphics activity and the amount of work needed to maintain the cache is greater than the amount of work that would be wasted by not using it (if any).
- "Double Size" toggles double-size mode, which makes the emulation window twice as big. When emulating a 80-column PET, only the height is doubled, so that the aspect ratio is closer to that of the real thing.
- "Double Scan" toggles double-scan mode, which causes the emulator to draw only odd lines when running in double-size mode (this saves some CPU time and also makes the emulation window look more like an old monitor).
- `Use XSync()" causes the emulator to call the X11 function `XSync()` before updating the emulation window: this might be necessary on low-end systems to prevent it from consuming so many system resources that it becomes impossible for the user to interact with it.

### 6.4.1 Video resources

The following resources affect the screen emulation. The prefix of some of the resources and commandline options denote the video chip the values apply to.

`UseXSync`
  Boolean specifying whether `XSync()` is called after updating the emulation window.
`MITSHM`
  Integer specifying whether VICE should try to use the shared memory extensions (MITSHM) when starting up. The shared memory extensions make things a lot faster but might not be available on your system. You will not be able to use these extensions if you are sitting at an X terminal while running the emulator on a remote machine across a network. Valid values are: 0 = do not use MITSHM, 1 = do use MITSHM, -1 = try to autodetect availability on startup (default). The last is a simple test if the emulator runs across a network and if so disables MITSHM (If you have problems with this test please report it).
`PrivateColormap`
  Boolean specifying whether VICE should install a private colormap at startup. This makes sense for 8-bit displays that could run out of colors if other color-hungry applications are running at the same time.
`DisplayDepth`
  Integer specifying the depth of the host display. The value ``0'` (the default) causes the emulator to autodetect it.

### 6.4.2 Video command-line options

`-xsync`
`+xsync`
  Enable/disable usage of `XSync()` when updating the emulation window (`UseXSync=1`, `UseXSync=0`).
`-mitshm`
`+mitshm`
  Enable/disable usage of the MITSHM extensions (`MITSHM=1`, `MITSHM=0`).
`-install`
`+install`
  Enable/disable installation of a private colormap (`PrivateColormap=1`, `PrivateColormap=0`).
`-displaydepth DEPTH`
  Specify the display depth (`DisplayDepth`).
`-fullscreen`
`+fullscreen`
  Enable/disable fullscreen mode

## 6.5 Keyboard settings

It is possible to specify whether the "positional" or "symbolic" keyboard mapping should be used with the "Keyboard mapping type" submenu (see section 2.7 The keyboard emulation for an explanation of positional and symbolic mappings).

The keyboard settings submenu also allows you to:

- Load custom-made positional and symbolic keymap files ("Set symbolic keymap file" and "Set positional keymap file").
- Dump the current keymap to a user-defined keymap file ("Dump to keymap file").

### 6.5.1 Keyboard resources

`KeymapIndex`
  Integer identifying which keymap is being used; `0` indicates symbolic mapping, `1` positional mapping. For the PET the even values represent symbolic mapping, odd positional. Then add `0` for UK business keyboard or `2` for graphics keyboard.
`KeymapSymFile`
  String specifying the name of the keymap file for the symbolic mapping (see section 2.7 The keyboard emulation, all but PET and CBM-II).
`KeymapPosFile`
  String specifying the name of the keymap file for the positional mapping (see section 2.7 The keyboard emulation, all but PET and CBM-II).
`KeymapBusinessUKSymFile`
`KeymapBusinessUKPosFile`
  String specifying the name of the keymap file for the symbolic and positional mapping for the UK business keyboard (see section 2.7 The keyboard emulation, PET and CBM-II).
`KeymapGraphicsSymFile`
`KeymapGraphicsPosFile`
  String specifying the name of the keymap file for the symbolic and positional mapping for the graphics keyboard (see section 2.7 The keyboard emulation, PET only).
`KeymapBusinessDESymFile`
`KeymapBusinessDEPosFile`
  String specifying the name of the keymap file for the symbolic and positional mapping for the German business keyboard. (see section 2.7 The keyboard emulation, PET only).

### 6.5.2 Keyboard command-line options

`-keymap N`
  Specifies which keymap is being used; `0` indicates symbolic mapping, `1` positional mapping (as for the `KeymapIndex` resource).
`-symkeymap NAME`
  Specify ``NAME'` as the symbolic keymap file (`KeymapSymFile`).
`-poskeymap NAME`
  Specify ``NAME'` as the positional keymap file (`KeymapPosFile`).
`-symdekeymap NAME`
  Specify ``NAME'` as the symbolic keymap file (`KeymapSymDeFile`).
`-buksymkeymap NAME`
`-bukposkeymap NAME`
  Specify ``NAME'` as the symbolic/positional keymap file for the UK business keyboard (`KeymapBusinessUKSymFile`, `KeymapBusinessUKPosFile`, PET and CBM-II).
`-grsymkeymap NAME`
`-grposkeymap NAME`
  Specify ``NAME'` as the symbolic/positional keymap file for the graphics keyboard (`KeymapGraphicsSymFile`, `KeymapGraphicsPosFile`, PET only).
`-bdesymkeymap NAME`
`-bdeposkeymap NAME`
  Specify ``NAME'` as the symbolic/positional keymap file for the German business keyboard (`KeymapBusinessDESymFile`, `KeymapBusinessDEPosFile`, PET only).

## 6.6 Joystick settings

### 6.6.1 Joystick command-line options

`-joydev1 <0-8>`
`-joydev2 <0-8>`
  Set the device for joystick emulation of port 1 and 2, respectively (`JoyDevice1`, `JoyDevice2`).
`-extrajoydev1 <0-8>`
`-extrajoydev2 <0-8>`
  Set device for extra joystick port 1 and 2.
`-mouse`
`+mouse`
  Enable/Disable mouse grab
`-mousetype <value>`
  Select the mouse type (0 = 1351, 1 = NEOS, 2 = Amiga, 3 = Paddles)
`-mouseport <value>`
  Select the joystick port the mouse is attached to
`-lightpen`
`+lightpen`
  Enable/Disable lightpen emulation
`-lightpentype <type>`
  Set lightpen type

## 6.7 Sound settings

The following menu items control sound output:

- "Enable sound playback" turns sound emulation on and off.
- "Sound synchronization" specifies the method for syncronizing the sound playback. Possible settings are:
  - "Flexible", i.e., the audio renderer flexibly adds/removes samples to the output to smoothly adapt the playback to slight changes in the speed of the emulator.
  - "Adjusting" works like "flexible", but supports bigger differences in speed. For example, if the emulation speed drops down from from 100% to 50%, audio slows down by the same amount too.
  - "Exact", instead, makes the audio renderer output always the same sounds you would hear from the real thing, without trying to adapt the ratio; to compensate the tolerances in speed, some extra frames will be skipped or added.
- "Sample rate" specifies the sampling frequency, ranging from 8000 to 48000 Hz (not all the sound cards and/or sound drivers can support all the frequencies, so actually the nearest candidate will be chosen).
- "Buffer size" specifies the size of the audio buffer; the bigger the buffer, the longer the delay with which sounds are played. You should pick the smallest value your machine can handle without problems.
- "Sound suspend time", will cause the audio playback to pause for the specified number of seconds whenever some clicking happens. If "Keep going" is selected, no pausing is done.
- "Oversample" specifies an oversampling factor, from 1 to 8 times (warning: this eats CPU cycles!).

### 6.7.1 Sound resources

`Sound`
  Boolean specifying whether audio emulation is turned on.
`SoundSpeedAdjustment`
  Integer specifying what speed adjustment method the audio renderer should use. Possible values are:
  - `0`: "flexible"
  - `1`: "adjusting"
  - `2`: "exact"
`SoundSampleRate`
  Integer specifying the sampling frequency, ranging from 8000 to 48000 Hz (not all the sound cards and/or sound drivers can support all the frequencies, so actually the nearest candidate will be chosen).
`SoundBufferSize`
  Integer specifying the size of the audio buffer, in milliseconds.
`SoundSuspendTime`
  Integer specifying the pause interval when audio underflows ("clicks") happen. `0` means no pause is done.
`SoundDeviceName`
  String specifying the audio driver. Implemented drivers are:
  - `aix`, for the IBM AIX sound driver.
  - `uss`, for the Linux/FreeBSD Universal Sound System driver (`SoundDeviceArg` specifies the audio device, ``/dev/dsp'` by default);
  - `sgi`, for the Silicon Graphics audio device (`SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default);
  - `sun`, for the Solaris audio device (unfinished; `SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default).
  - `hpux`, for the HP-UX audio device (unfinished; `SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default).
  - `sdl`, for the Simple DirectMedia Layer audio driver.
  - `esd`, for EsounD, the Enlightened Sound Daemon; `SoundDeviceArg` specifies the ESD server (``host:port'`) to connect, empty by default.
  - `dummy`, fully emulating the SID, but not actually playing samples.
  - `dump`, writing all the write accesses to the registers to a file (specified by `SoundDeviceArg`, default value is `vicesnd.sid`);
  - `speed`, like `dummy` but also calculating samples (mainly used to evaluate the speed of the sample generator);
  - `fs`, writing samples to a file (specified by `SoundDeviceArg`; default is ``vicesnd.raw'`);
  These drivers will actually be present only if the VICE configuration script detected the corresponding devices at the time of compilation.
`SoundDeviceArg`
  String specifying an additional parameter for the audio driver (see `SoundDeviceName`).

### 6.7.2 Sound command-line options

`-sound`
`+sound`
  Turns sound emulation on (`Sound=1`) and off (`Sound=0`).
`-soundsync N`
  Specify `N` as the sound speed adjustment method (`SoundSpeedAdjustment`).
`-soundrate RATE`
  Specifies the sound playback sample rate (`SoundSampleRate`).
`-soundbufsize SIZE`
  Specifies the size of the audio buffer in milliseconds (`SoundBufferSize`).
`-soundfragsize <value>`
  Set sound fragment size (0 = small, 1 = medium, 2 = large)
`-sounddev NAME`
  Specifies the name of the audio device (`SoundDeviceName`).
`-soundarg ARG`
  Specifies an additional parameter for the audio device (`SoundDeviceArg`).
`-soundrecdev <name>`
  Specify recording sound driver
`-soundrecarg <args>`
  Specify initialization parameters for recording sound driver

## 6.8 Tape settings

These settings are used to control the hardware-level emulation of the Tape drive.

### 6.8.1 Tape command-line options

`-dsresetwithcpu`
`+dsresetwithcpu`
  Enable/Disable automatic Datasette-Reset
`-dszerogapdelay <value>`
  Set delay in cycles for a zero in the tap
`-dsspeedtuning <value>`
  Set number of cycles added to each gap in the tap

## 6.9 Drive settings

These settings are used to control the hardware-level emulation of the Disk drives. When hardware-level emulation is turned on, only drives 8 and 9 are being emulated.

The following settings affect both drives:

- "Enable true drive emulation" enables the (slow) hardware-level emulation of the drives for maximum compatibility. This must be turned on for any of the following settings to have effect.
- "Drive sync factor" specifies the speed of the drive's CPU. This can be used to help loading certain programs that have trouble with the default PAL setting (for example, programs designed for NTSC machines). The ratio is calculated as follows:

      sync_factor = 65536 * clk_drive / clk_machine

  where `clk_drive` and `clk_machine` are clock speeds in MHz. The menu lets you choose between the PAL and NTSC values, and also lets you specify whatever value you want. Be careful when changing it, though, because a wrong value can break things and even corrupt disk images.

The following settings, instead, are specific of each drive:

- "Drive model" specifies the model of the drive being emulated. Warning: This will reset the drive.
- "Enable parallel cable" enables emulation of a SpeedDOS parallel cable; if you switch this option on and replace the original Commodore ROMs with SpeedDOS-compatible ones, you can speed up loading/saving times.
- "Idle method" specifies which method the drive emulation should use to save CPU cycles in the host CPU. There are three methods:
  - Skip cycles: Each time the serial line is accessed by the C64, the drive executes all the cycles since the last time it ran. If the number of elapsed cycles is larger than a certain value, the drive discards part of them.
  - Trap idle: The disk drive is still emulated upon serial line accesses as with the previous option, but it is also always emulated at the end of each screen frame. If the drive gets into the DOS idle loop, only pending interrupts are emulated to save time.
  - No traps: Like "Trap idle", but without any traps at all. So basically the drive works exactly as with the real thing, and nothing is done to reduce the power needs of the drive emulation.
  The first option ("Skip cycles") is usually best for performance, as the drive is emulated as little as possible; on the other hand, you may notice sudden slowdowns (when the drive executes several cycles at once) and the LED status is never updated (because it would not be possible to do correctly so). Moreover, if the drive tries to get in sync with the computer in some weird way and the computer does not access the serial line for a long time, it is possible that some cycles are discarded and the sync is lost. Notice that this hack will have no effect on performance if a program continuously reads from the IEC port, as the drive will have to be fully emulated in any case (some stupid programs do this, even when they don't actually need to use the drive).

  The second option ("Trap idle") is usually a bit slower, as at least interrupts are always emulated, but ensures the LED state is always updated correctly and always keeps the drive and the computer in sync. On the other hand, if a program installs a non-standard idle loop in the drive, the drive CPU has to be emulated even when not necessary and the global emulation speed is then much slower.

- "40-track image support" specifies how 40-track ("extended") disk images should be supported. There are three possible ways:
  - "Never extend" never extends disk images at all (so if a program tries to write tracks beyond the 35th, it is not allowed to do so);
  - "Ask on extend" prompts the user as soon as a program tries to write tracks beyond the 35th, and the user can then choose whether he wants the disk image to be extended or not;
  - "Extend on access" simply extends the disk image as soon the program needs it, without prompting the user.

### 6.9.1 Drive resources

`DriveTrueEmulation`
  Boolean controlling whether the "true" drive emulation is turned on.
`Drive8Type`
`Drive9Type`
  Integers specifying the model number for drives 8 and 9. Possible values are `1541`, `1571`, `1581` and `2031`.
`Drive8ParallelCable`
`Drive9ParallelCable`
  Booleans controlling whether the SpeedDOS-compatible cable is emulated or not for drives 8 and 9.
`Drive8ExtendImagePolicy`
`Drive9ExtendImagePolicy`
  Integer specifying the policy for 40-track support for drives 8 and 9. Possible values are `0` (never extend), `1` (ask on extend), `2` (extend on access).
`Drive8IdleMethod`
`Drive9IdleMethod`
  Integers specifying the idling method for the drive CPU. Possible values are `0` (none), `1` (skip cycles), `2` (trap idle). See section 6.9 Drive settings.
`DosName1541`
`DosName1571`
`DosName1581`
`DosName2031`
  Strings specifying the names of the ROM images for the drive emulation.

### 6.9.2 Drive command-line options

`-truedrive`
`+truedrive`
  Turns true drive emulation on (`DriveTrueEmulation=1`) and off (`DriveTrueEmulation=0`), respectively.
`-drive8type TYPE`
`-drive9type TYPE`
`-drive10type TYPE`
`-drive11type TYPE`
  Specifies the drive types for drives 8-11, respectively. Possible values for `TYPE` are `1541`, `1571`, `1581` and `2031`.
`-parallel8 <type>`
`-parallel9 <type>`
`-parallel10 <type>`
`-parallel11 <type>`
  Set parallel cable type (0: none, 1: standard, 2: Dolphin DOS)
`-drive8idle NUM`
`-drive9idle NUM`
`-drive10idle NUM`
`-drive11idle NUM`
  Specifies `NUM` as the idling method for drives 8-11 (0: no traps, 1: skip cycles, 2: trap idle), respectively (`Drive8IdleMethod`, `Drive9IdleMethod`), `Drive10IdleMethod`), `Drive11IdleMethod`).
`-drive8extend NUM`
`-drive9extend NUM`
`-drive10extend NUM`
`-drive11extend NUM`
  Specifies `NUM` as the track 40 extend policy in drives 8 and 9, respectively (`Drive8ExtendImagePolicy`, `Drive9ExtendImagePolicy`).
`-dos1541 <name>`
`-dos1541II <name>`
`-dos1551 <name>`
`-dos1570 <name>`
`-dos1571 <name>`
`-dos1571cr <name>`
`-dos1581 <name>`
`-dos2031 <name>`
`-dos2040 <name>`
`-dos3040 <name>`
`-dos4040 <name>`
`-dos1001 <name>`
  Specify the ROM names for the 1541, 1541II, 1551, 1570, 1571, 1571cr, 1581, 2031, 2040, 3040, 4040 and 1001 emulation respectively.
`-drive8ram2000, +drive8ram2000`
`-drive9ram2000, +drive9ram2000`
`-drive10ram2000, +drive10ram2000`
`-drive11ram2000, +drive11ram2000`
  Enable/Disable 8KB RAM expansion at $2000-$3FFF
`-drive8ram4000, +drive8ram4000`
`-drive9ram4000, +drive9ram4000`
`-drive10ram4000, +drive10ram4000`
`-drive11ram4000, +drive11ram4000`
  Enable/Disable 8KB RAM expansion at $4000-$5FFF
`-drive8ram6000, +drive8ram6000`
`-drive9ram6000, +drive9ram6000`
`-drive10ram6000, +drive10ram6000`
`-drive11ram6000, +drive11ram6000`
  Enable/Disable 8KB RAM expansion at $6000-$7FFF
`-drive8ram8000, +drive8ram8000`
`-drive9ram8000, +drive9ram8000`
`-drive10ram8000, +drive10ram8000`
`-drive11ram8000, +drive11ram8000`
  Enable/Disable 8KB RAM expansion at $8000-$9FFF
`-drive8rama000, +drive8rama000`
`-drive9rama000, +drive9rama000`
`-drive10rama000, +drive10rama000`
`-drive11rama000, +drive11rama000`
  Enable/Disable 8KB RAM expansion at $A000-$BFFF
`-drive8profdos, +drive8profdos`
`-drive9profdos, +drive9profdos`
`-drive10profdos, +drive10profdos`
`-drive11profdos, +drive11profdos`
  Enable/Disable Professional DOS
`-profdos1571 <name>`
`Specify name of Professional DOS 1571 ROM image`

## 6.10 Peripheral settings

VICE is able to support some special peripherals:

- file system devices, pseudo-drives accessing the Unix file system;
- printers.

These features depend on some kernal traps that replace the existing routines in the original Commodore operating system with custom-made C routines.

### 6.10.1 Settings for file system devices

These settings deal with the drive-like peripherals connected to the bus of the emulated machine. The first setting relates to the parallel IEEE488 interface. With this interface a special engine is used to listen to the bus lines to translates them to the filesystem code. Thus the PET will always detect a drive for example, but it can also use drives 10 and 11 even together with true disk drive emulation.

- "Enable virtual devices", enables the peripheral access via the fast disk emulation (either kernal traps or IEEE488 interface). Both, filesystem and disk image access via fast drive emulation, are affected.

Four peripherals, numbered from 8 to 11, are accessible; each of them provides the following settings:

- "File system access", if enabled, allows the device to emulate a drive accessing a file system directory; note that when a disk image is attached to the same drive, the directory is no longer visible and the attached disk is used instead.
- "File system directory" specifies the directory to be accessed by the drive.
- "Convert P00 file names", if enabled, allows access to P00 files using their built-in name instead of the Unix one.
- "Create P00 files on save", if enabled, creates P00 files (instead of raw CBM files) whenever a program creates a file.

Note that, by default, all drives except 11 create P00 files on save, while drive 11 creates raw CBM files. Those files come without any header, but also with the filename restrictions given by the operating system VICE runs on.

#### 6.10.1.1 Resources for file system devices

`FSDevice8ConvertP00`
`FSDevice9ConvertP00`
`FSDevice10ConvertP00`
`FSDevice11ConvertP00`
  Booleans specifying whether on-read support for P00 files is enabled on drives 8, 9, 10 and 11 respectively (on by default).
`FSDevice8SaveP00`
`FSDevice9SaveP00`
`FSDevice10SaveP00`
`FSDevice11SaveP00`
  Booleans specifying whether the drives should create P00 files instead of plain CBM ones (on by default for drives 8-10, off for 11).
`FSDevice8HideCBMFiles`
`FSDevice9HideCBMFiles`
`FSDevice10HideCBMFiles`
`FSDevice11HideCBMFiles`
  Booleans specifying whether non-P00 files should be invisible to programs running in the emulator (do not hide by default).
`FSDevice8Dir`
`FSDevice9Dir`
`FSDevice10Dir`
`FSDevice11Dir`
  Strings specifying the directories to which drives 8, 9, 10 and 11 have access.

#### 6.10.1.2 Command-line options for file system devices

`-iecdevice8`
`+iecdevice8`
  Enable/Disable IEC device emulation for device #8
`-iecdevice9`
`+iecdevice9`
  Enable/Disable IEC device emulation for device #9
`-iecdevice10`
`+iecdevice10`
  Enable/Disable IEC device emulation for device #10
`-iecdevice11`
`+iecdevice11`
  Enable/Disable IEC device emulation for device #11
`-device8 <type>`
`-device9 <type>`
`-device10 <type>`
`-device11 <type>`
  Set device type for device 8-11 (0: NONE, 1: FILESYSTEM, 2: OPENCBM, 3: BLOCK DEVICE)
`-fs8 PATH`
`-fs9 PATH`
`-fs10 PATH`
`-fs11 PATH`
  Specify the paths for the file system access on drives 8, 9, 10 and 11, respectively (`FSDevice8Dir`, `FSDevice9Dir`, `FSDevice10Dir` and `FSDevice11Dir`).
`-flipname <name>`
  Specify name of the flip list file image

### 6.10.2 Printer settings

The VICE emulators can emulate printers connected to either the IEC buffer or the user port. Emulation can be achieved by redirecting the printer output to a file or by piping it through an external process. This is defined by so-called printer device file names; a printer device file name can be either a simple path, or a command name preceeded by a pipe symbol ``|'`.

For example, printer device ``filename'` will cause the output to be appended to the file ``filename'`, while printer device ``|lpr'` will cause the `lpr` command to be executed and be fed the printer output. The printer output will not be converted but saved as printed by the emulated machine.

Up to three printer devices may be specified through the following resources:

- device 1, whose default value is `print.dump`;
- device 2, whose default value is `|lpr`.
- device 3, whose default value is `|petlp -F PS|lpr`;

So, basically, by default printer device 1 will dump printer output to ``print.dump'`; printer device 2 will print it via `lpr` directly to the printer and device 3 will print it via `petlp` (a not-yet-complete utility that will produce Postscript output from the Commodore printer code) and then to the printer via `lpr`.

#### 6.10.2.1 Printer resources

`PrinterTextDevice1`
`PrinterTextDevice2`
`PrinterTextDevice3`
  Strings specifying the printer devices (see section 6.10.2 Printer settings).
`Printer4TextDevice`
`Printer5TextDevice`
  Integer (ranging from 0 to 2, for device 1-3) specifying what printer device (see section 6.10.2 Printer settings) the IEC printer is using.
`Printer4`
`Printer5`
  Integer specifying how the IEC printer (device 4-5) is being emulated. (0: NONE, 1: FS, 2: REAL)
`Printer4Driver`
`Printer5Driver`
  String specifying the IEC printer output driver.
`Printer4Output`
`Printer5Output`
  String specifying the IEC printer output device.
`PrinterUserport`
  Boolean specifying if the user-port printer is being emulated.
`PrinterUserportTextDevice`
  Integer (ranging from 0 to 2, for device 1-3) specifying what printer device the user-port printer is using.
`PrinterUserportDriver`
  String specifying the user-port printer output driver.
`PrinterUserportOutput`
  String specifying the user-port printer output device.

#### 6.10.2.2 Printer command-line options

`-iecdevice4`
`+iecdevice4`
  Enable/Disable IEC device emulation for device #4
`-iecdevice5`
`+iecdevice5`
  Enable/Disable IEC device emulation for device #5
`-device4 <type>`
`-device5 <type>`
  Set device type for device 4-5 (0: NONE, 1: FS, 2: REAL)
`-prtxtdev1 <name>`
`-prtxtdev2 <name>`
`-prtxtdev3 <name>`
  Specify name of printer text device or dump file
`-pr4txtdev <0-2>`
`-pr5txtdev <0-2>`
  Specify printer text output device for IEC printer #4-5
`-pr4output <name>`
`-pr5output <name>`
  Specify name of output device for device #4-5 Specify name of output device for device #5-5
`-pr4drv <name>`
`-pr5drv <name>`
  Specify name of printer driver for device #4-5 Specify name of printer driver for device #5-5
`-pruser`
`+pruser`
  Enable/disable emulation of the userport printer emulation (`PrUser=1`, `PrUser=0`).
`-prusertxtdev <0-2>`
  Specify printer text output device for userport printer
`-pruseroutput <name>`
  Specify name of output device for the userport printer
`-pruserdrv <name>`
  Specify name of printer driver for the userport printer

### 6.10.3 Disabling kernal traps

If you have compatibility problems, you can completely disable Kernal traps with the "Disable kernal traps" option. This will of course disable all the features that depend on it, such as the fast 1541 emulation (so you will have to turn true 1541 emulation on if you want to be able to read or write disk images) and tape support.

#### 6.10.3.1 Resources to control Kernal traps

`VirtualDevices`
  Boolean specifying whether all the mechanisms for virtual device emulation should be enabled. Serial IEC devices use kernal traps, parallel IEEE488 devices use an own IEEE488 engine. Both are switched on and off with this resource.

#### 6.10.3.2 Command-line options to control Kernal traps

`-virtualdev`
`+virtualdev`
  Enable (`VirtualDevices=1`) or disable (`VirtualDevices=0`) virtual devices.

## 6.11 RS232 settings

The VICE emulators can emulate the RS232 device most of the machines have. The C64, C128 and VIC20 emulators emulate the userport RS232 interface at 300 and 1200 baud. The C64 and C128 can also use the 9600 baud interface by Daniel Dallmann, using the shift registers of the two CIA 6526 chips. The PET can have a 6551 ACIA RS232 interface when running as a SuperPET, and the CBM-II has such an ACIA by default. The C64 and C128 emulators can emulate an ACIA 6551 (also known as Datapump for example) as extension at `$de**`.

Emulation can be achieved by either:

- connecting a real UNIX serial device;
- dumping to a file;
- piping through a process.

It is possible to define up to four UNIX serial devices, and then decide which interface should be connected to which device. This is done by so-called rs232 device file names; an rs232 device file name can be either a simple path, or a command name preceeded by a pipe symbol ``|'`. If the path specifies a special device (e.g. ``/dev/ttyS0'`) it is recognized by VICE and the emulator can set the baudrate.

For example, rs232 device ``filename'` will cause the output to be written (not appended) to the file ``filename'`, while printer device ``|lpr'` will cause the `lpr` command to be executed and be fed the rs232 output. The rs232 output will not be converted but saved as sent by the emulated machine. The same holds true for the rs232 input. If the command writes data to the standard output it will be caught by VICE and sent back to the emulator. Also the data sent by the pseudo device will be sent back to VICE.

For example you can setup a null-modem cable between two serial ports of your PC, setup one port for login and use the other in VICE. Then you can login from your emulator via the RS232 emulation and the null-modem cable to your machine again.

You can not simply run a shell from VICE, as the shell will notice that it does not run on its own pseudo terminal and will thus buffer its output. You need to write some program that opens an own pseudo terminal and runs the shell from there (not yet finished).

Up to four RS232 devices may be specified through the following resources:

- device 1, whose default value is `/dev/ttyS0`;
- device 2, whose default value is `/dev/ttyS1`;
- device 3, whose default value is `rs232.dump`;
- device 4, whose default value is `|lpr`.

For the first two devices you can change the baudrate the tty device is set to by specifying it on the commandline or in the menu. This baudrate is 9600 by default for the latter two, but can be changed only by resources (The baudrate is independent from the baudrate the emulator actually expects).

### 6.11.1 RS232 resources

`RsDevice1`
`RsDevice2`
`RsDevice3`
`RsDevice4`
  Strings specifying the RS232 devices (see section 6.11 RS232 settings).
`RsDevice1Baud`
`RsDevice2Baud`
`RsDevice3Baud`
`RsDevice4Baud`
  Integer specifying the RS232 baudrate devices if the device file points to a special device (like ``/dev/ttyS0'`; see section 6.11 RS232 settings).
`Acia1Dev`
  Integer (ranging from 0 to 3, for device 1-4) specifying what RS232 device (see section 6.11 RS232 settings) the ACIA is using (all except VIC20).
`Acia1Irq`
  Integer specifying which interrupt to use. 0 = none, 1 = IRQ, 2 = NMI (C64 and C128 only)
`RsUserEnable`
  Boolean specifying if the user-port RS232 interface is being emulated (C64, C128 and VIC20).
`RsUserBaud`
  Integer specifying the baudrate of the user-port RS232 interface (C64, C128 and VIC20).
`RsUserDev`
  Integer (ranging from 0 to 3, for device 1-4) specifying what RS232 device the user-port interface is using (C64, C128 and VIC20).

### 6.11.2 RS232 command-line options

`-rsdev1 NAME`
`-rsdev2 NAME`
`-rsdev3 NAME`
`-rsdev4 NAME`
  Specify `NAME` as RS232 devices 1, 2, 3 and 4, respectively (`RsDevice1`, `RsDevice2` `RsDevice3` and `RsDevice4`).
`-rsdev1 BAUDRATE`
`-rsdev2 BAUDRATE`
`-rsdev3 BAUDRATE`
`-rsdev4 BAUDRATE`
  Specify `BAUDRATE` as baudrate for the RS232 devices if the device name specifies a special device (like ``/dev/ttyS0'` for example, see section 6.11 RS232 settings; `RsDevice1Baud`, `RsDevice2Baud` `RsDevice3Baud` and `RsDevice4Baud`).
`-myaciadev <0-3>`
  Specify RS232 device the ACIA should work on
`-rsuser`
`+rsuser`
  Enable or disable emulation of the userport RS232 emulation (`RsUser`; C64, C128 and VIC20)
`-rsuserbaud <baud>`
  Set the baud rate of the RS232 userport emulation.
`-rsuserdev <0-3>`
  Specify device for the userport RS232 emulation (`RsUserDev`; C64, C128 and VIC20).

### 6.11.3 RS232 usage example

Here we give you a simple example how to set up an emulated C64 using the modem connected to your PC. The following list shows each step.

`Attach your modem to your PC at a serial port.`
  Normally you should set it up to use the modem as "/dev/modem".
`start VICE`
`Setup VICE to use your modem as "serial device 1"`
  Go to the RS232 settings menu and change "Serial 1 device" to "/dev/modem" (or the device where you attached your modem to) Then go to the RS232 settings menu and change "Serial 1 baudrate" to the baudrate your modem should run at. Watch out, e.g. on Linux there is an additional multiplier to multiply with the baudrate (so e.g. 19200 gives 115200 or so baud) See the "setserial" manpage on Linux for example. However, most modems should be able to autodetect the speed to the computer as well.
`Select the RS232 emulation your programs use`
  If you want to use the Userport emulation, go to the RS232 settings and change "Userport RS232 Device" to "Serial 1". If you want ACIA emulation (swiftlink or what's it called?) then change "ACIA $DE** device" to "Serial 1".
`Enable the emulation`
  Go to the RS232 settings and select either "ACIA $DE** emulation" or Userport 300/1200 baud or CIA 9600 baud emulation.
`Load your program and start it.`
  If it is able to detect an RS232 cartridge like swiftlink or so, try to detect the ACIA emulation if enabled. Otherwise just set the baudrate to either 300, 1200 or 9600 according to what you enabled in the VICE menu for the userport.

## 6.12 Monitor settings

This section lists command-line options specific to the built-in monitor.

### 6.12.1 Monitor command-line options

`-moncommands FILENAME`
  Execute the commands from the file `FILENAME` in the monitor after starting up. This command line switch is mainly thought to load labels and to set breakpoints. Not all other commands are useful to be executed in this way, some may even lead to strange effects.
`-initbreak <address>`
  Set an initial breakpoint for the monitor. Addresses with prefix "0x" are hexadecimal.
`-remotemonitor`
`+remotemonitor`
  Enable/Disable remote monitor
`-remotemonitoraddress <name>`
  The local address the remote monitor should bind to

## 6.13 Machine settings

### 6.13.1 Machine command-line options

`-pal`
  Use PAL sync factor
`-ntsc`
  Use NTSC sync factor
`-ntscold`
  Use old NTSC sync factor
`-paln`
  Use PAL-N sync factor

## 6.14 Memory settings

### 6.14.1 Memory command-line options

`-raminitstartvalue <value>`
  Set the value for the very first RAM address after powerup
`-raminitvalueinvert <num of bytes>`
  Length of memory block initialized with the same value
`-raminitpatterninvert <num of bytes>`
  Length of memory block initialized with the same pattern

## 6.15 Miscellaneous settings

This section lists generic resources that do not fit in the other categories.

### 6.15.1 Miscellaneous resources

`Directory`
  String specifying the search path for system files. It is defined as a sequence of directory names, separated by colons (``:'`), just like the `PATH` variable in the shell. The special string ``$$'` stands for the default search path, which is initialized at startup to the following value:

      LIBDIR/EMUID:$HOME/.vice/EMUID:BOOTPATH/EMUID:LIBDIR/DRIVES:$HOME/.vice/DRIVES:BOOTPATH/DRIVES

  where:
  - `LIBDIR` is the VICE installation directory (usually ``/usr/local/lib/vice'`, ``/usr/lib/vice'` or ``/opt/vice/lib'`);
  - `EMUID` is the emulation identification string (`C64`, `C128`, `VIC20` or `PET`);
  - `BOOTPATH` is the directory where the binary lies (usually ``/usr/local/bin'`, ``/usr/bin'` or `/opt/vice/bin`).
  - `DRIVES` is the directory called "DRIVES", where the disk drive ROMs are. (The disk drive ROMs are used by all emulators, so there is an extra directory for them.)
  Notice that the middle entry points to a default location in the user's home directory. Here private ROM versions (e.g. speeddos or JiffyDos) can be stored for example. See section 4 System files. for a description of the method used to load the emulator's system files.
`HTMLBrowserCommand`
  String specifying the command to run the help browser. The help browser can be any HTML browser, and every ``%s'` in the string is replaced with the name of the toplevel file of the VICE documentation. For example, the default value ``netscape %s'` runs Netscape Navigator.
`SaveResourcesOnExit`
  Boolean specifying whether the emulator should save changed settings before exiting. If this is enabled, the user will be always prompted first, in case the settings have changed.
`DoCoreDump`
  Boolean specifying whether the emulator should dump core when it gets a signal.
`JoyDevice1`
`JoyDevice2`
  Integer specifying which joystick device the emulator should use for joystick emulation for ports 1 and 2, respectively (0=None, 1=Numpad, 2=Custom keys, 3=Analog joystick 1, 4=Analog joystick 2, 5=Digital joystick 1, 6=Digital joystick 2 on Unix) The available joysticks might differ depending on operating system and joystick support in the OS (Linux joystick module must be available for example).

### 6.15.2 Miscellaneous command-line options

`-directory SEARCHPATH`
  Specify the system file search path (`Directory`).
`-htmlbrowser COMMAND`
  Specify the command to run the HTML browser for the on-line help (`HTMLBrowserCommand`).
`-saveres`
`+saveres`
  Enable/disable automatic saving of settings on exit (`SaveResourcesOnExit=1`, `SaveResourcesOnExit=0`).
`-confirmexit`
  Confirm quiting VICE
`+confirmexit`
  Never confirm quiting VICE
`-core`
`+core`
  Enable/disable generation of core dumps (`DoCoreDump=1`, `DoCoreDump=0`).

Go to the first, previous, next, last section, table of contents.